    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.plot;
    034
    035import java.awt.Color;
    036
    037/**
    038 * A color source for use by the {@link PiePlot3D} class.  This is the
    039 * interface through which the plot will obtain colors for each data item
    040 * (segment) in the chart.  A default implementation
    041 * ({@link StandardColorSource}) is provided.
    042 */
    043public interface ColorSource<K extends Comparable<K>> {
    044
    045    /**
    046     * Returns the color for one data item in the chart.  We return a
    047     * {@code Color} rather than a paint, because some manipulations
    048     * that require a {@code Color} instance are done for the shading
    049     * during the 3D rendering.
    050     *
    051     * @param key  the key ({@code null} not permitted).
    052     *
    053     * @return The color.
    054     */
    055    Color getColor(K key);
    056
    057    /**
    058     * Sets the color associated with the specified key.  If the supplied
    059     * color is {@code null}, this will have the effect of clearing any
    060     * previous setting and reverting to the default color.
    061     *
    062     * @param key  the key ({@code null} not permitted).
    063     * @param color  the color ({@code null} permitted).
    064     */
    065    void setColor(K key, Color color);
    066
    067    /**
    068     * Restyles the source using the specified colors.  Refer to the
    069     * implementing class to confirm the precise behaviour (typically all
    070     * existing color settings are cleared and the specified colors are
    071     * installed as the new defaults).
    072     *
    073     * @param colors  the colors.
    074     *
    075     * @since 1.2
    076     */
    077    void style(Color... colors);
    078
    079}
    080